local grenade_table = {
    molotov = true,
    wpn_prj_ace = true,
    wpn_prj_jav = true,
    wpn_prj_four = true,
    wpn_prj_hur = true,
    wpn_prj_target = true,
    fir_com = true
}
if RequiredScript == "lib/managers/playermanager" then
    local PlayerManager_Can_Throw_Grenade_Original = PlayerManager.can_throw_grenade
    function PlayerManager:can_throw_grenade(...)
        if managers.groupai:state():whisper_mode() and not grenade_table[managers.blackmarket:equipped_grenade()] then
            return
        end
        return PlayerManager_Can_Throw_Grenade_Original(self, ...)
    end
 
elseif RequiredScript == "lib/network/handlers/unitnetworkhandler" then
    local UnitNetworkHandler_Server_Throw_Grenade_Original = UnitNetworkHandler.request_throw_projectile
    function UnitNetworkHandler:request_throw_projectile(projectile_type, ...)
        local proj_name = tweak_data.blackmarket:get_projectile_name_from_index(projectile_type)
        if managers.groupai:state():whisper_mode() and not grenade_table[proj_name] then
            return
        end
        return UnitNetworkHandler_Server_Throw_Grenade_Original(self, projectile_type, ...)
    end
end